import { TRPCRequestOptions } from '@trpc/client';
import type { CreateTRPCClientOptions } from '@trpc/client';
import type { AnyRouter, inferHandlerInput, inferProcedureInput } from '@trpc/server';
import type { TRPCResult } from '@trpc/server/rpc';
import type { Getter } from 'jotai';
declare type ValueOrGetter<T> = T | ((get: Getter) => T);
export declare function createAtomCreators<TRouter extends AnyRouter>(opts: CreateTRPCClientOptions<TRouter>): {
    client: import("@trpc/client/dist/declarations/src/internals/TRPCClient").TRPCClient<TRouter>;
    atomWithQuery: <TPath extends keyof TRouter["_def"]["queries"] & string>(path: TPath, getInput: ValueOrGetter<inferHandlerInput<TRouter["_def"]["queries"][TPath]>>, getOptions?: ValueOrGetter<TRPCRequestOptions>, getClient?: ((get: Getter) => import("@trpc/client/dist/declarations/src/internals/TRPCClient").TRPCClient<TRouter>) | undefined) => import("jotai").Atom<Promise<import("@trpc/server").ThenArg<ReturnType<TRouter["_def"]["queries"][TPath]["call"]>>>>;
    atomWithMutation: <TPath_1 extends keyof TRouter["_def"]["mutations"] & string>(path: TPath_1, getClient?: ((get: Getter) => import("@trpc/client/dist/declarations/src/internals/TRPCClient").TRPCClient<TRouter>) | undefined) => import("jotai").WritableAtom<Awaited<ReturnType<TRouter["_def"]["mutations"][TPath_1]["call"]>> | null, [...inferHandlerInput<TRouter["_def"]["mutations"][TPath_1]>, TRPCRequestOptions?], Promise<void>> & {
        init: Awaited<ReturnType<TRouter["_def"]["mutations"][TPath_1]["call"]>> | null;
    };
    atomWithSubscription: <TPath_2 extends keyof TRouter["_def"]["subscriptions"] & string>(path: TPath_2, getInput: ValueOrGetter<inferProcedureInput<TRouter["_def"]["subscriptions"][TPath_2]>>, getOptions?: ValueOrGetter<TRPCRequestOptions>, getClient?: ((get: Getter) => import("@trpc/client/dist/declarations/src/internals/TRPCClient").TRPCClient<TRouter>) | undefined) => import("jotai").Atom<TRPCResult<ReturnType<import("@trpc/server").ThenArg<ReturnType<TRouter["_def"]["subscriptions"][TPath_2]["call"]>>["output"]>>>;
};
export {};
